<?php
/**
 * 画像ユニット高機能版.
 *
 * @package units
 *
 * @copyright 2008-2016 Shift Tech Inc. All Rights Reserved.
 * @author    シフトテック株式会社<http://www.shift-tech.jp>
 *
 * @version   1.7.x
 */
require_once LIB_PATH.'/common/unitCommon.php';
/**
 * 動画ユニット高機能版.
 */
class extFixedImg extends unitCommon
{
    //------ ユニット毎に必ず設定しなくてはならない変数 -------//
    /** @var string $_table 公開用テーブル名 unit_multiple_data */
    public $_table = 'unit_multiple_data';       //公開用テーブル名
    /** @var string $_tmptable 下書き用テーブル名 unit_multiple_data_tmp */
    public $_tmptable = 'unit_multiple_data_tmp'; //下書き用テーブル名
    /** @var string $_unit_dir ユニットディレクトリ名 */
    public $_unit_dir = 'extFixedImg';
    /** @var array $columns テーブル列設定 */
    public $columns = array(
        array('column' => 'pageu_code', 'conv' => 'n', 'tags' => false),  //ユニット個別ID
        array('column' => 'pageu_unit_code', 'conv' => 'n', 'tags' => false),  //ユニット個別ID
        array('column' => 'pageu_unit_name', 'conv' => 'Kva', 'tags' => false),  //ユニット個別ID
        array('column' => 'mlt_data1', 'conv' => 'Kva', 'tags' => false),  //データ1
        array('column' => 'mlt_data2', 'conv' => 'Kva', 'tags' => true),  //データ2
        array('column' => 'mlt_data3', 'conv' => 'Kva', 'tags' => false),  //データ3
        array('column' => 'mlt_data4', 'conv' => 'Kva', 'tags' => false),  //データ4
        array('column' => 'mlt_data5', 'conv' => 'Kva', 'tags' => false),  //データ5
        array('column' => 'mlt_data6', 'conv' => 'Kva', 'tags' => false),  //データ6
        array('column' => 'mlt_data7', 'conv' => 'Kva', 'tags' => false),  //データ7
        array('column' => 'mlt_data8', 'conv' => 'Kva', 'tags' => false),  //データ8
        array('column' => 'mlt_data9', 'conv' => 'Kva', 'tags' => false),  //データ9
        array('column' => 'mlt_data10', 'conv' => 'Kva', 'tags' => false),  //データ10
        array('column' => 'mlt_data11', 'conv' => 'Kva', 'tags' => false),  //データ11
        array('column' => 'mlt_data12', 'conv' => 'Kva', 'tags' => false),  //データ12
        array('column' => 'mlt_data13', 'conv' => 'Kva', 'tags' => false),  //データ13
        array('column' => 'mlt_data14', 'conv' => 'Kva', 'tags' => false),  //データ14
        array('column' => 'mlt_data15', 'conv' => 'Kva', 'tags' => false),  //データ15
        array('column' => 'mlt_data16', 'conv' => 'Kva', 'tags' => false),  //データ16
        array('column' => 'mlt_data17', 'conv' => 'Kva', 'tags' => false),  //データ17
        array('column' => 'mlt_data18', 'conv' => 'Kva', 'tags' => false),  //データ18
        array('column' => 'mlt_data19', 'conv' => 'Kva', 'tags' => false),  //データ19
        array('column' => 'mlt_data20', 'conv' => 'Kva', 'tags' => false),  //データ20
        array('column' => 'mlt_data21', 'conv' => 'Kva', 'tags' => false),  //データ21
        array('column' => 'mlt_data22', 'conv' => 'Kva', 'tags' => false),  //データ22
        array('column' => 'mlt_data23', 'conv' => 'Kva', 'tags' => false),  //データ23
        array('column' => 'mlt_data24', 'conv' => 'Kva', 'tags' => false),  //データ24
        array('column' => 'mlt_data25', 'conv' => 'Kva', 'tags' => false),  //データ25
        array('column' => 'mlt_data26', 'conv' => 'Kva', 'tags' => false),  //データ26
        array('column' => 'mlt_data27', 'conv' => 'Kva', 'tags' => false),  //データ27
        array('column' => 'mlt_data28', 'conv' => 'Kva', 'tags' => false),  //データ28
        array('column' => 'mlt_data29', 'conv' => 'Kva', 'tags' => false),  //データ29
        array('column' => 'mlt_data30', 'conv' => 'Kva', 'tags' => false),  //データ30
        array('column' => 'mlt_data31', 'conv' => 'Kva', 'tags' => false),  //データ31
        array('column' => 'mlt_data32', 'conv' => 'Kva', 'tags' => false),  //データ32
        array('column' => 'mlt_data33', 'conv' => 'Kva', 'tags' => false),  //データ33
        array('column' => 'mlt_data34', 'conv' => 'Kva', 'tags' => false),  //データ34
        array('column' => 'mlt_data35', 'conv' => 'Kva', 'tags' => false),  //データ35
        array('column' => 'mlt_data36', 'conv' => 'Kva', 'tags' => false),  //データ36
        array('column' => 'mlt_data37', 'conv' => 'Kva', 'tags' => false),  //データ37
        array('column' => 'mlt_data38', 'conv' => 'Kva', 'tags' => false),  //データ38
        array('column' => 'mlt_data39', 'conv' => 'Kva', 'tags' => false),  //データ39
        array('column' => 'mlt_data40', 'conv' => 'Kva', 'tags' => false),  //データ40
        array('column' => 'mlt_data41', 'conv' => 'Kva', 'tags' => false),  //データ41
        array('column' => 'mlt_data42', 'conv' => 'Kva', 'tags' => false),  //データ42
        array('column' => 'mlt_data43', 'conv' => 'Kva', 'tags' => false),  //データ43
        array('column' => 'mlt_data44', 'conv' => 'Kva', 'tags' => false),  //データ44
        array('column' => 'mlt_data45', 'conv' => 'Kva', 'tags' => false),  //データ45
        array('column' => 'mlt_data46', 'conv' => 'Kva', 'tags' => false),  //データ46
        array('column' => 'mlt_data47', 'conv' => 'Kva', 'tags' => false),  //データ47
        array('column' => 'mlt_data48', 'conv' => 'Kva', 'tags' => false),  //データ48
        array('column' => 'mlt_data49', 'conv' => 'n', 'tags' => false),  //データ49
        array('column' => 'mlt_data50', 'conv' => 'n', 'tags' => false),  //データ50
        array('column' => 'mlt_data51', 'conv' => 'n', 'tags' => false),  //データ50
        array('column' => 'bg_color', 'conv' => 'n', 'tags' => false),    //背景色
        array('column' => 'bdr_type', 'conv' => 'n', 'tags' => false),    //枠線
        array('column' => 'btm_padding', 'conv' => 'n', 'tags' => false),  //下方スペース
        array('column' => 'bg_color_sp', 'conv' => 'n', 'tags' => false),    //背景色
        array('column' => 'bdr_type_sp', 'conv' => 'n', 'tags' => false),    //枠線
        array('column' => 'btm_padding_sp', 'conv' => 'n', 'tags' => false),  //下方スペース
        array('column' => 'use_pc_flg', 'conv' => 'n', 'tags' => false),  //PCフラグ
        array('column' => 'use_sp_flg', 'conv' => 'n', 'tags' => false),  //スマホフラグ
        array('column' => 'extra_class', 'conv' => 'as', 'tags' => false),  //追加クラス
        array('column' => 'option_extend', 'conv' => 'n', 'tags' => false),  //デザインオプションの継承
    );
    /** @var array $column_link テーブル列とフォーム名のマッピング用配列 */
    public $column_link = array(
        1 => 'anchor_text',
        2 => 'unit_sync',
        3 => 'img',
        4 => 'img_hover',
        //5 => 'align',
        6 => 'size',
        7 => 'size_w',
        8 => 'size_h',
        //9 => 'radius',
        //10 => 'radius_unit',
        11 => 'effect',
        12 => 'effect_duration',
        13 => 'click_action',
        14 => 'click_url',
        15 => 'alt',
        //16 => 'caption',
        //17 => 'caption_align',
        17 => 'btn_direction',
        //18 => 'caption_axis',
        18 => 'direction_unit',
        //19 => 'caption_pos',
        19 => 'direction_pos',
        //20 => 'caption_font',
        //21 => 'caption_size',
        //22 => 'caption_size_unit',
        //23 => 'caption_color',
        //24 => 'caption_line_height',
        //25 => 'caption_letter_spacing',
        //26 => 'caption_bgcolor',
        27 => 'img_sp',
        //28 => 'align_sp',
        29 => 'size_sp',
        30 => 'size_w_sp',
        31 => 'size_h_sp',
        //32 => 'radius_sp',
        //33 => 'radius_unit_sp',
        34 => 'click_action_sp',
        35 => 'click_url_sp',
        36 => 'alt_sp',
        //37 => 'caption_sp',
        //38 => 'caption_align_sp',
        38 => 'btn_direction_sp',
        //39 => 'caption_axis_sp',
        39 => 'direction_unit_sp',
        //40 => 'caption_pos_sp',
        40 => 'direction_pos_sp',
        //41 => 'caption_font_sp',
        //42 => 'caption_size_sp',
        //43 => 'caption_size_unit_sp',
        //44 => 'caption_color_sp',
        //45 => 'caption_line_height_sp',
        //46 => 'caption_letter_spacing_sp',
        //47 => 'caption_bgcolor_sp',
        48 => 'animatecsshelp',
        49 => 'animatecsshelp_speed',
        50 => 'animatecsshelp_delay',
        51 => 'animatecsshelp_timing',
    );
    //▼変数宣言///////////////////
    /** @var array $_data データ */
    public $_data;
    private $effect = array(
        null => '無し',
        'fade' => 'フェード',
    );
    /*
    private $align = array(
        'left' => '左',
        'center' => '中央',
        'right' => '右',
    );*/
    
    
    private $size = array(
        //null => '---',
        'original' => 'オリジナル',
        'fixsize' => '指定サイズ',
    );
    private $click_action = array(
        null => '---',
        //'popup' => 'ポップアップで表示',
        //'Lightbox' => 'ライトボックスで表示',
        '_self' => 'リンク：_self',
        '_blank' => 'リンク：_blank',
        '_parent' => 'リンク：_parent',
        '_top' => 'リンク：_top',
    );
    private $axis = array(
        null => '---',
        'top' => '上から',
        'bottom' => '下から',
    );
    private $direction = array(
        'right' => '右から出現。上からの固定表示位置は',
        'left' => '左から出現。上からの固定表示位置は',
        'bottom' => '下から出現。左からの固定表示位置は',
        'top' => '上から出現。左からの固定表示位置は'
    );
    
    
    //▲変数宣言///////////////////

    /**
     * コンストラクタ
     */
    public function __construct()
    {
        unitCommon::__construct();
    }
    /**
     * 出力データセット処理.
     *
     * @return null|array
     */
    public function setDisplayData()
    {
        if (!class_exists('imgmngrDB')) {
            include LIB_PATH.'/common/imgmngrDB.php';
        }
        $imgmngrDB = new imgmngrDB();
        $this->_data = $this->getDetail();
        $props = $this->getProp($this->_pageu_code);
        $unitCss = array();
        $this->_view->assign('isSP', 0);
        //▼データ操作  ////////
        if ($this->_data != null) {
            $this->_data['class'] = $this;
            if($this->_data['animatecsshelp']!="") {
                $this->_data['extra_class'] .= " attach2_anim attach2_".$this->_data['animatecsshelp'];
                //2019.01.29
                //fixed設定
                $fixed_css["position"]="fixed";
                $fixed_css["z-index"]="101";
                switch($this->_data["btn_direction"]) {
                    case "right": //右から出現
                        $fixed_css["right"]="0";
                        $fixed_css["top"]="1px";
                        if(isset($this->_data["direction_pos"]) && $this->_data["direction_pos"] > 0) {
                            $fixed_css["top"]=$this->_data["direction_pos"];
                            $fixed_css["top"].=$this->_data["direction_unit"];
                        }
                        if(preg_match('/.+In.*/', $this->_data['animatecsshelp'])) {
                            $this->_data['extra_class'] .="Right";
                        }
                        break;
                    case "left":
                        $fixed_css["left"]="0";
                        $fixed_css["top"]="1px";
                        if(isset($this->_data["direction_pos"]) && $this->_data["direction_pos"] > 0) {
                            $fixed_css["top"]=$this->_data["direction_pos"];
                            $fixed_css["top"].=$this->_data["direction_unit"];
                        }
                        if(preg_match('/.+In.*/', $this->_data['animatecsshelp'])) {
                            $this->_data['extra_class'] .="Left";
                        }
                        break;
                    case "top":
                        $fixed_css["left"]="0";
                        $fixed_css["top"]="1px";
                        if(isset($this->_data["direction_pos"]) && $this->_data["direction_pos"] > 0) {
                            $fixed_css["left"]=$this->_data["direction_pos"];
                            $fixed_css["left"].=$this->_data["direction_unit"];
                        }
                        if(preg_match('/.+In.*/', $this->_data['animatecsshelp'])) {
                            $this->_data['extra_class'] .="Down";
                        }
                        break;
                    case "bottom":
                        $fixed_css["left"]="0";
                        $fixed_css["bottom"]="1px";
                        //$fixed_css["margin-bottom"]="-1px";
                        if(isset($this->_data["direction_pos"]) && $this->_data["direction_pos"] > 0) {
                            $fixed_css["left"]=$this->_data["direction_pos"];
                            $fixed_css["left"].=$this->_data["direction_unit"];
                        }
                        if(preg_match('/.+In.*/', $this->_data['animatecsshelp'])) {
                            $this->_data['extra_class'] .="Up";
                        }
                        break;
                }
                $this->_data["fixed_css"]=json_encode($fixed_css);

		  //スマホ時
 if ($this->checkSP()) {
		//スマホ時
                if($this->_data['unit_sync'] == 1) {
                    //PCを継承時はPCパラメータで上書きしておく
                    $this->_data["fixed_css_sp"] = $this->_data["fixed_css"];
                } else {
			$this->_data['extra_class'] = " attach2_anim attach2_".$this->_data['animatecsshelp'];
		 //fixed設定
		 $fixed_css=null;
                $fixed_css["position"]="fixed";
                $fixed_css["z-index"]="101";
                switch($this->_data["btn_direction_sp"]) {
                    case "right": //右から出現
                        $fixed_css["right"]="0";
                        $fixed_css["top"]="1px";
                        if(isset($this->_data["direction_pos_sp"]) && $this->_data["direction_pos_sp"] > 0) {
                            $fixed_css["top"]=$this->_data["direction_pos_sp"];
                            $fixed_css["top"].=$this->_data["direction_unit_sp"];
                        }
                        if(preg_match('/.+In.*/', $this->_data['animatecsshelp'])) {
                            $this->_data['extra_class'] .="Right";
                        }
                        break;
                    case "left":
                        $fixed_css["left"]="0";
                        $fixed_css["top"]="1px";
                        if(isset($this->_data["direction_pos_sp"]) && $this->_data["direction_pos_sp"] > 0) {
                            $fixed_css["top"]=$this->_data["direction_pos_sp"];
                            $fixed_css["top"].=$this->_data["direction_unit_sp"];
                        }
                        if(preg_match('/.+In.*/', $this->_data['animatecsshelp'])) {
                            $this->_data['extra_class'] .="Left";
                        }
                        break;
                    case "top":
                        $fixed_css["left"]="0";
                        $fixed_css["top"]="1px";
                        if(isset($this->_data["direction_pos_sp"]) && $this->_data["direction_pos_sp"] > 0) {
                            $fixed_css["left"]=$this->_data["direction_pos_sp"];
                            $fixed_css["left"].=$this->_data["direction_unit_sp"];
                        }
                        if(preg_match('/.+In.*/', $this->_data['animatecsshelp'])) {
                            $this->_data['extra_class'] .="Down";
                        }
                        break;
                    case "bottom":
                        $fixed_css["left"]="0";
                        $fixed_css["bottom"]="1px";
                        //$fixed_css["margin-bottom"]="-1px";
                        if(isset($this->_data["direction_pos_sp"]) && $this->_data["direction_pos_sp"] > 0) {
                            $fixed_css["left"]=$this->_data["direction_pos_sp"];
                            $fixed_css["left"].=$this->_data["direction_unit_sp"];
                        }
                        if(preg_match('/.+In.*/', $this->_data['animatecsshelp'])) {
                            $this->_data['extra_class'] .="Up";
                        }
                        break;
                }
                $this->_data["fixed_css_sp"]=json_encode($fixed_css);





		 }
}
            }
            if ($this->checkSP()) {
                //スマホ時
                if($this->_data['unit_sync'] == 1) {
                    //PCを継承時はPCパラメータで上書きしておく
                    $props[1] = $props[0];
                }
                if(is_array($props) && isset($props[1])) {
                    $this->_data = array_merge($this->_data, $props[1]);
                }

                if($this->_data['unit_sync'] != 1) {
                    foreach($this->_data as $k=>$v) {
                        if(preg_match("/(.*)_sp$/", $k, $m)) {
                            $this->_data[$m[1]] = $this->_data[$m[0]];
                        }
                    }
                }

                $this->_view->assign('isSP', 1);
            } else {
                if(is_array($props) && isset($props[0])) {
                    $this->_data = array_merge($this->_data, $props[0]);
                }
            }

            //共通プロパティ（余白とか）
            $unitStyle = $this->createUnitStyle($this->_data);
            if(0 < count($unitStyle)) {
                $this->_data['unitStyle'] = implode(' ', $unitStyle);
            }

            $this->_data['unitAttr']=array('style'=>array());
            if($this->_data['animatecsshelp']!="" && preg_match('/.+Out.*/', $this->_data['animatecsshelp'])) {
                $this->_data['unitAttr']['style'][] = "visibility: visible;";
            }
            if($this->_data['animatecsshelp_speed']!="" && is_numeric($this->_data['animatecsshelp_speed'])) {
                $this->_data['unitAttr']['style'][] = "animation-duration: ".$this->_data['animatecsshelp_speed']."ms;";
            }
            if($this->_data['animatecsshelp_delay']!="" && is_numeric($this->_data['animatecsshelp_delay'])) {
                $this->_data['unitAttr']['style'][] = "animation-delay: ".$this->_data['animatecsshelp_delay']."ms;";
            }
            if($this->_data['animatecsshelp_timing']!="" && is_numeric($this->_data['animatecsshelp_timing'])) {
                $this->_data['unitAttr']['data-offset'][] = $this->_data['animatecsshelp_timing'];
            }

            //画像サイズを取得しておく
            if ($this->_data['img']!="" && file_exists(BASE_PATH.UNITS_IMG_PATH.$this->_data['img'])) {
                $info = $imgmngrDB->getimagesizeall(BASE_PATH.UNITS_IMG_PATH.$this->_data['img']);
                if(is_array($info)){
                    $info[3] = str_replace('"','', $info[3]);
                    $this->_data['imgInfo'] = $info;
                }
            }
            if ($this->_data['img_hover']!="" && file_exists(BASE_PATH.UNITS_IMG_PATH.$this->_data['img_hover'])) {
                $info = $imgmngrDB->getimagesizeall(BASE_PATH.UNITS_IMG_PATH.$this->_data['img_hover']);
                if(is_array($info)){
                    $info[3] = str_replace('"','', $info[3]);
                    $this->_data['imgHoverInfo'] = $info;
                }
            }

            $innerStyle = "";
            $imgStyle = "";
            
            if($this->_data["size"]=="fixsize"){
                if($this->_data["size_w"] != "") {
                    $ut = "";
                    if(is_numeric($this->_data["size_w"])) {
                        $ut = "px";
                    }
                    $imgStyle.="width:".$this->_data["size_w"].$ut.";";
                } else {
                    //$imgStyle.="width: auto;";
                }
                if($this->_data["size_h"]!="") {
                    $ut = "";
                    if(is_numeric($this->_data["size_h"])) {
                        $ut = "px";
                    }
                    $imgStyle.="height:".$this->_data["size_h"].$ut.";";
                    $imgStyle.="height:".$this->_data["size_h"].$ut.";";
                }
            } elseif($this->_data["size"]=="original") {
                if(!is_null($this->_data['imgInfo'])) {
                    $imgStyle.="width:".$this->_data['imgInfo'][0]."px;";
                } else {

                }
            }
            //2019.01.29 originalに固定
            /*
            $this->_data["size"]="original";
            if(!is_null($this->_data['imgInfo'])) {
                $imgStyle.="width:".$this->_data['imgInfo'][0]."px;";
            } else {

            }
            */
            if($this->_data["btn_direction"] == "right") {
                $this->_data["align"]="right";
            } else if($this->_data["btn_direction"] == "left") {
                $this->_data["align"]="left";
            } else if($this->_data["btn_direction"] == "top") {
                $this->_data["align"]="center";
            } else if($this->_data["btn_direction"] == "bottom") {
                $this->_data["align"]="center";
            }
            
            
            
            
            if(0 < count($imgStyle)) {
                $innerStyle .= "vertical-align: top;";
            }
            /*
            if($this->_data["radius"]!=""){
                $innerStyle.="border-radius: ".$this->_data["radius"].$this->_data["radius_unit"].";";
            }*/

            $this->_data["imgStyle"] = ($imgStyle=="" ? "" : "style=\"".$imgStyle."\"");
            $this->_data["innerStyle"] = ($innerStyle=="" ? "" : "style=\"".$innerStyle."\"");

            //テキストスタイル
            /*
            $captionStyle = array();
            $captionStyle = $this->createTextStyle(
                $this->_data['caption_font'],
                $this->_data["caption_size"].$this->_data["caption_size_unit"],
                $this->_data["caption_color"],
                $this->_data["caption_line_height"],
                $this->_data["caption_letter_spacing"],
                null,
                null,
                null,
                null,
                null,
                null
            );

            if($this->_data["caption_axis"]!=""){
                $captionStyle[] = $this->_data["caption_axis"].": ".$this->_data["caption_pos"]."%; ";
            }

            if($this->_data["caption_bgcolor"]!=""){
                $captionStyle[] = "background-color: rgba(".$this->_data["caption_bgcolor"].");";
            }

            if(0 < count($captionStyle)) {
                $this->_data['captionStyle'] = implode(' ', $captionStyle);
            }*/
        }

        //▲データ操作  ////////
        $this->_view->assign('pageu_code', $this->_pageu_code);
        $this->_view->assign('data', $this->_data);
        $this->_view->assign('ua', $this->_ua);

        return $this->_data;
    }
    /**
     * DBより保存データ取得.
     *
     * @return null|array
     */
    public function getDetail()
    {
        $sql = 'SELECT * FROM '.$this->getTbl().' WHERE pageu_code = ?';
        if (isset($this->_pageu_code) && is_numeric($this->_pageu_code)) {
            $result = $this->db->prepare($sql, $this->_pageu_code);
            $row = $result->fetchRow(DB_FETCHMODE_ASSOC);
            $data = $this->replaceMultipleData($row, $this->column_link);

            if ($data['img']) {
                $data['image'] = BINGOTOPURL.UNITS_IMG_PATH.$data['img'];
            }
            if ($data['img_hover']) {
                $data['image_hover'] = BINGOTOPURL.UNITS_IMG_PATH.$data['img_hover'];
            }
            if (Model::checkSP()) {
                if($data['unit_sync'] != 1) {
                    if ($data['img_sp']) {
                        $data['image'] = BINGOTOPURL.UNITS_IMG_PATH.$data['img_sp'];
                    }
                }
                if ($data['img_hover']) {
                    $data['image_hover'] = null;
                }
            }
        }

        return $data;
    }
    /**
     * フォーム初期値をセット.
     */
    public function setDefault()
    {
        $this->_view->assign('addCss', "\n<link href=\"".BINGOTOPURL.'/usr-data/units/'.$this->_unit_dir."/admin/admin.css\" rel=\"stylesheet\" type=\"text/css\" media=\"all\">\n");
        $this->_data = $this->getDetail();
        $this->_data = $this->getProperty4device($this->_data);

        if (!$this->_data) {
            //$this->_data['align'] = 'left';
            //$this->_data['radius_unit'] = 'px';
            
            /*$this->_data['caption_align'] = 'center';
            $this->_data['caption_axis'] = 'bottom';
            $this->_data['caption_size_unit'] = 'px';
            $this->_data['caption_color'] = '#333333';
            $this->_data['caption_bgcolor'] = '255,255,255,0.6';*/

            /*$this->_data['align_sp'] = 'left';*/
            /*
            $this->_data['radius_unit_sp'] = 'px';
            $this->_data['caption_align_sp'] = 'center';
            $this->_data['caption_axis_sp'] = 'bottom';
            $this->_data['caption_size_unit_sp'] = 'px';
            $this->_data['caption_color_sp'] = '#333333';
            $this->_data['caption_bgcolor_sp'] = '255,255,255,0.6';
            */
            $this->_data['effect_duration'] = '0.2';
            $this->_data['direction_pos'] = '50';
            $this->_data['direction_unit'] = '%';
            $this->_data['direction_unit_sp'] = '%';
            $this->_data['animatecsshelp'] = 'slideIn';
            $this->_data['animatecsshelp_speed'] = '1000';

            $this->_data['unit_sync'] = 1;
        } else {
            if ($this->_data['img']) {
                $this->_view->assign('image', BINGOTOPURL.UNITS_IMG_PATH.$this->_data['img']);
            }
            if ($this->_data['img_sp']) {
                $this->_view->assign('image_sp', BINGOTOPURL.UNITS_IMG_PATH.$this->_data['img_sp']);
            }
            if ($this->_data['img_hover']) {
                $this->_view->assign('image_hover', BINGOTOPURL.UNITS_IMG_PATH.$this->_data['img_hover']);
            }
        }
        $this->_form->setDefaults($this->_data);
    }
    /**
     * フォームエレメントの作成.
     */
    public function setElements()
    {
        if(isset($_POST['animatecsshelp_speed'])) {
            $this->_data['animatecsshelp_speed'] = $_POST['animatecsshelp_speed'];
        }
        if(isset($_POST['animatecsshelp_delay'])) {
            $this->_data['animatecsshelp_delay'] = $_POST['animatecsshelp_delay'];
        }
        if(isset($_POST['animatecsshelp_timing'])) {
            $this->_data['animatecsshelp_timing'] = $_POST['animatecsshelp_timing'];
        }
        $this->_view->assign('data', $this->_data);
        $this->_form->addElement('hidden', 'pageu_code', $this->_pageu_code, array('id' => 'pageu_code')); //ページコード
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, _gettext('しない'), 1, array('labelClass'=>'radioBtn')),
            $this->_form->createElement('radio', null, null, _gettext('する'), 0, array('labelClass'=>'radioBtn')),
        ), 'unit_sync', '', '');

        //画像
        $this->_form->addElement('hidden', 'img', null, array('id' => 'img'));
        $this->_form->addElement('hidden', 'img_hover', null, array('id' => 'img_hover'));

        //整列
        /*
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, 'left', 'left', array('labelClass' => 'radioBtn alignL')),
            $this->_form->createElement('radio', null, null, 'center', 'center', array('labelClass' => 'radioBtn alignC')),
            $this->_form->createElement('radio', null, null, 'right', 'right', array('labelClass' => 'radioBtn alignR')),
        ), 'align', '', '');
        */
        
        //サイズ
        $this->_form->addElement('select', 'size', null, $this->size, array('class' => 'size pulldown'));
        //幅
        $this->_form->addElement('text', 'size_w', null, array('class' => 'numL', 'maxlength'=>'6', 'placeholder' => '100%'));
        //高さ
        $this->_form->addElement('text', 'size_h', null, array('class' => 'numL', 'maxlength'=>'6', 'placeholder' => 'auto'));
        
        /*
        //角丸
        $this->_form->addElement('text', 'radius', null, array('class' => 'num', 'maxlength'=>'3'));
        //角丸単位
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, 'px', 'px', array('labelClass' => 'radioBtn')),
            $this->_form->createElement('radio', null, null, '%', '%', array('labelClass' => 'radioBtn')),
        ), 'radius_unit', '', '');
        */
        //ホバーエフェクト
        $this->_form->addElement('select', 'effect', null, $this->effect, array('class' => 'effect pulldown'));
        //ホバーアニメーション時間
        $this->_form->addElement('text', 'effect_duration', null, array('id' => 'effect_duration', 'class' => 'num', 'maxlength'=>'3'));
        //クリック動作
        $this->_form->addElement('select', 'click_action', null, $this->click_action, array());
        //URL
        $this->_form->addElement('text', 'click_url', null, array());
        //代替テキスト
        $this->_form->addElement('text', 'alt', null, array());
        /*
        //キャプション
        $this->_form->addElement('textarea', 'caption', null, array());
        //キャプション整列
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, 'left', 'left', array('labelClass' => 'radioBtn alignL')),
            $this->_form->createElement('radio', null, null, 'center', 'center', array('labelClass' => 'radioBtn alignC')),
            $this->_form->createElement('radio', null, null, 'right', 'right', array('labelClass' => 'radioBtn alignR')),
        ), 'caption_align', '', '');
        //キャプションY位置
        $this->_form->addElement('select', 'caption_axis', null, $this->axis, array());
        //キャプション位置
        $this->_form->addElement('text', 'caption_pos', null, array('id' => 'caption_pos', 'class' => 'numM', 'maxlength'=>'4'));
        //キャプションフォント
        $this->_form->addElement('hidden', 'caption_font', null, array());
        //キャプションサイズ
        $this->_form->addElement('text', 'caption_size', null, array('id' => 'caption_size', 'class' => 'numM', 'maxlength'=>'4'));
        //キャプションサイズ単位
        $radio = array(
            $this->_form->createElement('radio', null, '', 'px', 'px', array('id' =>'caption_size_unit_0','labelClass' => 'radioBtnS')),
            $this->_form->createElement('radio', null, '', 'em', 'em', array('id' =>'caption_size_unit_1','labelClass' => 'radioBtnS')),
            $this->_form->createElement('radio', null, '', '%', '%', array('id' =>'caption_size_unit_2','labelClass' => 'radioBtnS')),
        );
        $this->_form->addGroup($radio, 'caption_size_unit', '', '');
        //キャプション色
        $this->_form->addElement('text', 'caption_color', null, array());
        //キャプション行間
        $this->_form->addElement('text', 'caption_line_height', null, array('class' => 'numM', 'maxlength' => '4'));
        //キャプション文字間
        $this->_form->addElement('text', 'caption_letter_spacing', null, array('class' => 'numM', 'maxlength' => '4'));
        //キャプション背景色
        $this->_form->addElement('text', 'caption_bgcolor', null, array());
        */
        //スマホ　画像
        $this->_form->addElement('hidden', 'img_sp', null, array('id' => 'img_sp'));
        //スマホ　整列
        /*
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, 'left', 'left', array('labelClass' => 'radioBtn alignL')),
            $this->_form->createElement('radio', null, null, 'center', 'center', array('labelClass' => 'radioBtn alignC')),
            $this->_form->createElement('radio', null, null, 'right', 'right', array('labelClass' => 'radioBtn alignR')),
        ), 'align_sp', '', '');
        */
        //スマホ　サイズ
        $this->_form->addElement('select', 'size_sp', null, $this->size, array('class' => 'size size_sp pulldown'));
        //スマホ　幅
        $this->_form->addElement('text', 'size_w_sp', null, array('class' => 'num numL', 'maxlength'=>'6', 'placeholder' => '100%'));
        //スマホ　高さ
        $this->_form->addElement('text', 'size_h_sp', null, array('class' => 'num numL', 'maxlength'=>'6', 'placeholder' => 'auto'));
        
        /*
        //スマホ　角丸
        $this->_form->addElement('text', 'radius_sp', null, array('class' => 'num', 'maxlength'=>'3'));
        //スマホ　角丸単位
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, 'px', 'px', array('labelClass' => 'radioBtn')),
            $this->_form->createElement('radio', null, null, '%', '%', array('labelClass' => 'radioBtn')),
        ), 'radius_unit_sp', '', '');
        */
        //スマホ　クリック動作
        $this->_form->addElement('select', 'click_action_sp', null, $this->click_action, array());
        //スマホ　URL
        $this->_form->addElement('text', 'click_url_sp', null, array());
        //スマホ　代替テキスト
        $this->_form->addElement('text', 'alt_sp', null, array());
        //スマホ　キャプション
        /*
        $this->_form->addElement('textarea', 'caption_sp', null, array());
        //スマホ　キャプション整列
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, 'left', 'left', array('labelClass' => 'radioBtn alignL')),
            $this->_form->createElement('radio', null, null, 'center', 'center', array('labelClass' => 'radioBtn alignC')),
            $this->_form->createElement('radio', null, null, 'right', 'right', array('labelClass' => 'radioBtn alignR')),
        ), 'caption_align_sp', '', '');
        //スマホ　キャプションY位置
        $this->_form->addElement('select', 'caption_axis_sp', null, $this->axis, array());
        //スマホ　キャプション位置
        $this->_form->addElement('text', 'caption_pos_sp', null, array('id' => 'caption_pos', 'class' => 'numM', 'maxlength'=>'4'));
        //スマホ　キャプションフォント
        $this->_form->addElement('hidden', 'caption_font_sp', null, array());
        //スマホ　キャプションサイズ
        $this->_form->addElement('text', 'caption_size_sp', null, array('id' => 'caption_size_sp', 'class' => 'numM', 'maxlength'=>'4'));
        //スマホ　キャプションサイズ単位
        $radio = array(
            $this->_form->createElement('radio', null, '', 'px', 'px', array('id' =>'caption_size_unit_sp_0','labelClass' => 'radioBtnS')),
            $this->_form->createElement('radio', null, '', 'em', 'em', array('id' =>'caption_size_unit_sp_1','labelClass' => 'radioBtnS')),
            $this->_form->createElement('radio', null, '', '%', '%', array('id' =>'caption_size_unit_sp_2','labelClass' => 'radioBtnS')),
        );
        $this->_form->addGroup($radio, 'caption_size_unit_sp', '', '');
        //スマホ　キャプション色
        $this->_form->addElement('text', 'caption_color_sp', null, array());
        //スマホ　キャプション行間
        $this->_form->addElement('text', 'caption_line_height_sp', null, array('class' => 'numM', 'maxlength' => '4'));
        //スマホ　キャプション文字間
        $this->_form->addElement('text', 'caption_letter_spacing_sp', null, array('class' => 'numM', 'maxlength' => '4'));
        //スマホ　キャプション背景色
        $this->_form->addElement('text', 'caption_bgcolor_sp', null, array());*/

        //設定継承
        // $this->_form->addElement('advcheckbox', 'unit_sync', null, _gettext('B_P01061'), array('id' => 'unit_sync'), array(0, 1));

        //アンカー用テキスト
        $this->_form->addElement('text', 'anchor_text', null, array('id' => 'anchor_text', 'class' => 'txt'));
        
        
        //2019.01.29
        $this->_form->addElement('select', 'btn_direction', null, $this->direction, array());
        $this->_form->addElement('text', 'direction_pos', null, array('class' => 'num', 'maxlength'=>'3'));
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, 'px', 'px', array('labelClass' => 'radioBtn')),
            $this->_form->createElement('radio', null, null, '%', '%', array('labelClass' => 'radioBtn')),
        ), 'direction_unit', '', '');
        
        $this->_form->addElement('select', 'btn_direction_sp', null, $this->direction, array());
        $this->_form->addElement('text', 'direction_pos_sp', null, array('class' => 'num', 'maxlength'=>'3'));
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, 'px', 'px', array('labelClass' => 'radioBtn')),
            $this->_form->createElement('radio', null, null, '%', '%', array('labelClass' => 'radioBtn')),
        ), 'direction_unit_sp', '', '');
        
        

        $fontDB = new fontDB();
        $fonts = $fontDB->getUseFonts($isKey=true);
        $this->_view->addLoadFont($fonts);
        $this->_view->assign('font', $fonts[$this->_data['caption_font']]);
        $this->_view->assign('font_sp', $fonts[$this->_data['caption_font_sp']]);
    }
    /**
     * フォーム入力エラーチェックの設定.
     */
    public function setRules()
    {
        $this->_form->applyFilter('__ALL__', 'trim');
        $this->_form->_submitValues = DataBase::ConvColumnVals($this->_form->_submitValues, $this->columns); //ルールに従った値変換、タグの除去
        $this->_form->setJsWarnings('下記の項目が不正です。', '');
        $this->_form->addRule('pageu_code', '・「ユニットコード」が不明です。コンテンツ管理よりやり直してください', 'required', null, $this->erchk);

        $this->_form->registerRule('check_css_property2', 'regex', "/^\d+$|\d+(px|%)$|^auto$/");
        $this->_form->addRule('img', _gettext('B_P01029', array('画像')), 'required', null);
        /*
        $this->_form->addRule('size_w', _gettext('B_P01048', array('横幅')), 'check_css_property2', null, null, 'server');
        $this->_form->addRule('size_h', _gettext('B_P01048', array('高さ')), 'check_css_property2', null, null, 'server');
        $this->_form->addRule('radius', _gettext('B_P01031', array('ラウンド')), 'numeric', null, null, 'server');
        */
        $this->_form->addRule('effect_duration', _gettext('B_P01031', array('切り替わり時間')), 'numeric', null, null, 'server');
        $val = $this->_form->getElement('click_action')->getValue();
        if (!empty($val[0]) && $val[0] != 'popup' && $val[0] != 'Lightbox') {
            $this->_form->addRule('click_url', _gettext('B_P01029', array('URL')), 'required', null, $this->erchk);
        }
        /*
        $this->_form->addRule('caption_pos', _gettext('B_P01031', array('キャプションの位置')), 'numeric', null, null, 'server');
        $this->_form->addRule('caption_size', _gettext('B_P01031', array('キャプションの文字サイズ')), 'numeric', null, null, 'server');
        $this->_form->addRule('caption_line_height', _gettext('B_P01031', array('キャプションの行間')), 'numeric', null, null, 'server');
        $this->_form->addRule('caption_letter_spacing', _gettext('B_P01031', array('キャプションの文字間')), 'numeric', null, null, 'server');
        */
        $val = $this->_form->getElement('unit_sync')->getValue();
        if($val != 1 && !isset($_POST['pc2sp']['img'])) {
            $this->_form->addRule('img_sp', _gettext('B_P01029', array('画像（スマホ）')), 'required', null);
        }
        /*
        $this->_form->addRule('size_w_sp', _gettext('B_P01048', array('横幅（スマホ）')), 'check_css_property2', null, null, 'server');
        $this->_form->addRule('size_h_sp', _gettext('B_P01048', array('高さ（スマホ）')), 'check_css_property2', null, null, 'server');
        $this->_form->addRule('radius_sp', _gettext('B_P01031', array('ラウンド（スマホ）')), 'numeric', null, null, 'server');
        */
        $val = $this->_form->getElement('click_action_sp')->getValue();
        if (!empty($val[0]) && $val[0] != 'popup' && $val[0] != 'Lightbox') {
            $this->_form->addRule('click_url_sp', _gettext('B_P01029', array('URL（スマホ）')), 'required', null, $this->erchk);
        }
        /*
        $this->_form->addRule('caption_pos_sp', _gettext('B_P01031', array('キャプションの位置（スマホ）')), 'numeric', null, null, 'server');
        $this->_form->addRule('caption_size_sp', _gettext('B_P01031', array('キャプションの文字サイズ（スマホ）')), 'numeric', null, null, 'server');
        $this->_form->addRule('caption_line_height_sp', _gettext('B_P01031', array('キャプションの行間（スマホ）')), 'numeric', null, null, 'server');
        $this->_form->addRule('caption_letter_spacing_sp', _gettext('B_P01031', array('キャプションの文字間（スマホ）')), 'numeric', null, null, 'server');
        */
        $this->_form->addRule('direction_pos', _gettext('B_P01031', array('表示位置')), 'numeric', null, null, 'server');
        $this->_form->addRule('direction_pos_sp', _gettext('B_P01031', array('表示位置(スマホ)')), 'numeric', null, null, 'server');
        
        
    }
    /**
     * データ下書き保存処理.
     *
     * @param array $post 保存データ
     *
     * @return null|string エラー時=string
     */
    public function doSave($post)
    {
        include LIB_PATH.'/common/imgmngrDB.php';

        if (!is_numeric($post['pageu_code'])) {
            return '・データの保存に失敗しました';
        }

        $unit_sync = $post['unit_sync'];
        /*
        $post['caption'] = bUtil::completionHTML($post['caption']);
        $post['caption_sp'] = bUtil::completionHTML($post['caption_sp']);
        */
        if(isset($post['pc2sp'])) {
            if(isset($post['pc2sp']['img'])) {
                //IMG
                $post['img_sp'] = $post['img'];
            }
            if(isset($post['pc2sp']['alt'])) {
                //ALT
                $post['alt_sp'] = $post['alt'];
            }
            if(isset($post['pc2sp']['caption'])) {
                //CAPTION
                //$post['caption_sp'] = $post['caption'];
            }
        }
        $post = $this->replaceMultipleData($post, $this->column_link, 'mlt_data', true);

        //既存データがあるか確認
        $old_data = $this->getDetail();
        $record = null;
        foreach ($this->columns as $val) {
            if ($post[$val['column']] != null) {
                $record[$val['column']] = $post[$val['column']];
            } else {
                $record[$val['column']] = null;
            }
        }

        if($unit_sync == 1) {
            $record['bg_color_sp'] = $record['bg_color'];
            $record['bdr_type_sp'] = $record['bdr_type'];
            $record['btm_padding_sp'] = $record['btm_padding'];

            foreach($this->column_link as $k=>$v) {
                if(preg_match("/(.*)_sp$/", $v, $m)){
                    $record['mlt_data'.array_search($v, $this->column_link)] = $record['mlt_data'.array_search($m[1], $this->column_link)];
                }
            }
        }

        $record['pageu_unit_code'] = $this->_unit_data['unit_code'];
        $record['pageu_unit_name'] = $this->_unit_data['unit_name'];

        //effect無しの時は時間を更新しない
        /*if ($record['mlt_data26'] == '') {
            unset($record['mlt_data27']);
        }*/

        //画像コピー用
        $cparr = array();
        $delKey = array(null, 'img_hover_del', null);
        //PC 3,4 SP 27
        foreach(array(3,4,27) as $k => $v) {
            $postimage = $this->setPostImage($v, $record, $old_data, $delKey[$k], $k);
            if(!is_array($postimage)) {
                //エラー
                return $postimage;
            }
            $record = $postimage[0];
            $cparr[] = $postimage[1];
        }

        $this->db->query('BEGIN');
        //保存処理開始
        //基本データ
        if (is_array($old_data) && count($old_data) > 0) {
            //更新
            if (!$this->db->update($this->getTbl(), $record, 'pageu_code='.$record['pageu_code'])) {
                $this->db->query('ROLLBACK');

                return '・データの保存に失敗しました';
            }
        } else { //新規
            if (!$this->db->insert($this->getTbl(), $record)) {
                $this->db->query('ROLLBACK');

                return '・データの保存に失敗しました';
            }
        }

        //画像保存
        if (is_array($cparr)) {
            //ASP版用
            if (defined('PRODUCT_VERSION')) {
                foreach ($cparr as $v) {
                    foreach ($v as $src => $dist) {
                        $fsize[] = array('size' => filesize(BASE_PATH.$src));
                    }
                }
                if (count($fsize) > 0 && !commonFile::chkSaveFiles($fsize)) {
                    $this->db->query('ROLLBACK');

                    return _gettext('B_P00281');
                }
            }

            foreach ($cparr as $v) {
                foreach ($v as $src => $dist) {
                    if (!copy(BASE_PATH.$src, BASE_PATH.$dist)) {
                        $this->db->query('ROLLBACK');

                        return _gettext('B_P00650');
                    } else {
                        @chmod(BASE_PATH.$dist, 0666);
                    }
                }
            }
        }

        $this->db->query('COMMIT');

        return;
    }

    /**
     * 画像をセット　保存時用
     *
     * unit_multiple_data_tmpが対象
     *
     */
    private function setPostImage($fcode, $post_data, $old_data, $del_key='', $index=0) {
        $copyFile = array();
        if (isset($_POST[$del_key]) && $_POST[$del_key] == 1) {
            //パス
            $post_data['mlt_data'.$fcode] = null;
        } else {
            $file = $post_data['mlt_data'.$fcode];
            if (is_numeric($file)) {
                //数値の時は更新
                $img_code = $file;
                $imginfo = null;
                $imgmngrDB = new imgmngrDB();
                $imgdata = $imgmngrDB->getImageFromCode($img_code, UNITS_IMG_PATH, $post_data['pageu_code'], $index);
                if (isset($imgdata)) {
                    $data_path = $imgdata['img_src']; // コピー元（素材管理の画像パス）
                    $img_path = $imgdata['gimg_src'];  // コピー先（公開用の画像パス）
                    $imginfo = $imgmngrDB->getimagesizeall(BASE_PATH.$data_path);
                    $post_data['mlt_data'.$fcode] = array_pop(explode('/', $img_path)); //保存ファイル名取得
                    $copyFile[$data_path] = $img_path;
                } else {
                    // return _gettext('B_P00651');
                }
            }
        }

        return array($post_data, $copyFile);
    }
}
